package com.example.cameraapp;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.hardware.Camera;
import android.hardware.Camera.PictureCallback;
import android.provider.MediaStore;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

public class CameraView extends SurfaceView implements SurfaceHolder.Callback, PictureCallback{
	private SurfaceHolder	holder;
	private Camera camera;

	public CameraView(Context context){
		super(context);

		holder=getHolder();
		holder.addCallback(this);

		holder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
	}
	public void surfaceCreated(SurfaceHolder holder){
		try{
			camera=Camera.open();
			camera.setPreviewDisplay(holder);
		}catch(Exception e){
		}
	}
	public void surfaceChanged(SurfaceHolder holder, int format, int w, int h){
		camera.startPreview();
	}
	public void surfaceDestroyed(SurfaceHolder holder){
		camera.setPreviewCallback(null);
		camera.stopPreview();
		camera.release();
		camera=null;
	}

	@Override
	public boolean onTouchEvent(MotionEvent event) {
		if (event.getAction()==MotionEvent.ACTION_DOWN) {
			camera.takePicture(null,null,this);
		}
		return true;
	}

	public void onPictureTaken(byte[] data, Camera camera) {
		Bitmap bmp = BitmapFactory.decodeByteArray(data, 0, data.length, null);
		MediaStore.Images.Media.insertImage(getContext().getContentResolver(), bmp, "", null);
		camera.startPreview();
	}
}